local dataobject = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_Speed", {
	type = "data source",
	icon = "Interface\\Icons\\Ability_Rogue_Sprint.blp",
	label = "Speed",
	suffix = "%",
	value = 0,
})

local floor = math.floor
local format = string.format
local cos = math.cos
local GetUnitSpeed = GetUnitSpeed
local speed, pitch
local function UpdateSpeed(frame,elapsed)
	local newspeed = GetUnitSpeed("player")
	if newspeed == speed then return end
	speed = newspeed

	local icon = "Interface\\Icons\\Ability_Rogue_Sprint"
	if UnitOnTaxi("player") then
		icon = "Interface\\CURSOR\\Taxi"
	elseif IsSwimming() then
		icon = "Interface\\Icons\\Ability_Druid_AquaticForm"
	elseif IsFlying() then
		icon = "Interface\\Icons\\Ability_Druid_FlightForm"
	elseif IsFalling() then
		icon = "Interface\\Icons\\Spell_Magic_FeatherFall"
	elseif IsMounted() then
		icon = "Interface\\Icons\\Ability_Mount_RidingHorse"
	end
	dataobject.icon = icon
	dataobject.value = floor(speed / BASE_MOVEMENT_SPEED * 100 + 0.1)
	dataobject.text = dataobject.value .. dataobject.suffix
end

local frame = CreateFrame("Frame")
frame:SetScript("OnUpdate", UpdateSpeed)

dataobject.OnTooltipShow = function(tooltip)
	local _, runspeed, flightspeed, swimspeed = GetUnitSpeed("player")
	tooltip:AddLine("Speed")
	if IsFlying() then
		tooltip:AddDoubleLine(
			("|T%s:0|t%s"):format("Interface\\Icons\\Ability_Druid_FlightForm", "Flying"),
			("%d%%"):format(floor(runspeed / BASE_MOVEMENT_SPEED * 100 + 0.1))
		)
	elseif IsMounted() then
		tooltip:AddDoubleLine(
			("|T%s:0|t%s"):format("Interface\\Icons\\Ability_Mount_RidingHorse", "Mounted"),
			("%d%%"):format(floor(runspeed / BASE_MOVEMENT_SPEED * 100 + 0.1))
		)
	else
		tooltip:AddDoubleLine(
			("|T%s:0|t%s"):format("Interface\\Icons\\Ability_Rogue_Sprint", "Running"),
			("%d%%"):format(floor(runspeed / BASE_MOVEMENT_SPEED * 100 + 0.1))
		)
	end
	tooltip:AddDoubleLine(
		("|T%s:0|t%s"):format("Interface\\Icons\\Ability_Druid_AquaticForm", "Swimming"),
		("%d%%"):format(floor(swimspeed / BASE_MOVEMENT_SPEED * 100 + 0.1))
	)
end
